Update Red Hat Copyright Notices
[nbdkit.git] / tests / test-retry.sh
blob70520165728403f2fb8d2b2d0e34599c2e4a96fb
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright Red Hat
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 source ./functions.sh
34 set -e
35 set -x
37 requires_plugin sh
38 requires_nbdcopy
39 requires dd iflag=count_bytes </dev/null
41 files="retry.img retry-count retry-open-count"
42 rm -f $files
43 cleanup_fn rm -f $files
45 touch retry-count retry-open-count
46 start_t=$SECONDS
48 # Create a custom plugin which will test retrying.
49 nbdkit -v -U - \
50 sh - \
51 --filter=retry retry-delay=1 \
52 --run 'nbdcopy "$uri" retry.img' <<'EOF'
53 #!/usr/bin/env bash
54 case "$1" in
55 open)
56 # Count how many times the connection is (re-)opened.
57 read i < retry-open-count
58 echo $((i+1)) > retry-open-count
60 pread)
61 # Fail 3 times then succeed.
62 read i < retry-count
63 ((i++))
64 echo $i > retry-count
65 if [ $i -le 3 ]; then
66 echo "EIO pread failed" >&2
67 exit 1
68 else
69 dd if=/dev/zero count=$3 iflag=count_bytes
73 get_size) echo 512 ;;
74 *) exit 2 ;;
75 esac
76 EOF
78 # In this test we should see 3 failures:
79 # pread FAILS
80 # retry and wait 1 seconds
81 # pread FAILS
82 # retry and wait 2 seconds
83 # pread FAILS
84 # retry and wait 4 seconds
85 # pread succeeds
87 # The minimum time for the test should be 1+2+4 = 7 seconds.
88 end_t=$SECONDS
89 if [ $((end_t - start_t)) -lt 7 ]; then
90 echo "$0: test ran too quickly"
91 exit 1
94 # Check the handle was opened 4 times (first open + one reopen for
95 # each retry).
96 read open_count < retry-open-count
97 if [ $open_count -ne 4 ]; then
98 echo "$0: open-count ($open_count) != 4"
99 exit 1